# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe GitLabCI do
      include_context 'with_branch_and_sha'
      let(:gitlab_ci) { 'true' }
      let(:environment) do
        {
          'GITLAB_CI' => gitlab_ci,
          'CI_BUILD_REF_NAME' => branch,
          'CI_BUILD_REF' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with GITLAB_CI set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with GITLAB_CI set to `true` (default)'

        context 'with GITLAB_CI set to nil' do
          let(:gitlab_ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with GITLAB_CI set to nil'
      end # describe '#matches?'
    end # RSpec.describe GitLabCI
  end # module Matchers
end # module LetItCrash
