# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe SnapCI do
      include_context 'with_branch_and_sha'
      let(:ci)      { 'true' }
      let(:snap_ci) { 'true' }
      let(:environment) do
        {
          'CI' => ci,
          'SNAP_CI' => snap_ci,
          'SNAP_BRANCH' => branch,
          'SNAP_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI and SNAP_CI set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI and SNAP_CI set to `true` (default)'

        context 'with CI set to nil' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI set to nil'

        context 'with SNAP_CI set to nil' do
          let(:snap_ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with SNAP_CI set to nil'
      end # describe '#matches?'
    end # RSpec.describe SnapCI
  end # module Matchers
end # module LetItCrash
