# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe SolanoCI do
      include_context 'with_branch_and_sha'
      let(:tddium) { 'true' }
      let(:environment) do
        {
          'TDDIUM' => tddium,
          'TDDIUM_CURRENT_BRANCH' => branch,
          'TDDIUM_CURRENT_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with TDDIUM set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with TDDIUM set to `true` (default)'

        context 'with TDDIUM set to nil' do
          let(:tddium) { nil }

          it { expect(result).to be_falsey }
        end # context 'with TDDIUM set to nil'
      end # describe '#matches?'
    end # RSpec.describe SolanoCI
  end # module Matchers
end # module LetItCrash
