# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe TeamCity do
      include_context 'with_branch_and_sha'
      let(:ci_server_name) { 'TeamCity' }
      let(:environment) do
        {
          'CI_SERVER_NAME' => ci_server_name,
          'TEAMCITY_BUILD_BRANCH' => branch,
          'TEAMCITY_BUILD_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI_SERVER_NAME set to `TeamCity` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI_SERVER_NAME set to `TeamCity` (default)'

        context 'with CI_SERVER_NAME set to nil' do
          let(:ci_server_name) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI_SERVER_NAME set to nil'
      end # describe '#matches?'
    end # RSpec.describe TeamCity
  end # module Matchers
end # module LetItCrash
