# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe Wercker do
      include_context 'with_branch_and_sha'
      let(:ci) { 'true' }
      let(:environment) do
        {
          'CI' => ci,
          'WERCKER_GIT_BRANCH' => branch,
          'WERCKER_GIT_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'when CI and WERCKER_GIT_BRANCH set (default)' do
          it { expect(result).to be_truthy }
        end # context 'when CI and WERCKER_GIT_BRANCH set (default)'

        context 'when WERCKER_GIT_BRANCH not set' do
          let(:branch) { nil }

          it { expect(result).to be_falsey }
        end # context 'when WERCKER_GIT_BRANCH not set'

        context 'when CI not set' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'when CI not set'
      end # describe '#matches?'
    end # RSpec.describe Wercker
  end # module Matchers
end # module LetItCrash
