# frozen_string_literal: true

require 'spec_helper'

# rubocop:disable RSpec/VerifiedDoubles
module LetItCrash
  module Reporters
    RSpec.describe Stream do
      let(:message)  { 'message' }
      let(:input)    { double(to_json: message) }
      let(:output)   { StringIO.new }
      let(:reporter) { described_class.new(output: output) }

      describe '#report' do
        let(:result) { reporter.report(input) }

        it 'changes output' do
          expect { result }
            .to change { output.string }
            .from('')
            .to(message)
        end
      end # describe '#report'
    end # RSpec.describe Stream
  end # module Reporters
end # module LetItCrash
